<?php
/*
Plugin Name: DojoExpert
Plugin Script: dojoexpert.php
Plugin URI: http://www.dojoexpert.com
Description: Plugin to embed memberlist and result
Version: 1.0
Author: DojoExpert
Author URI: http://www.dojoexpert.com

=== RELEASE NOTES ===
2014-09-10 - v1.0 - first version
*/

$memberlist_url = 'http://manager.dojoexpert.com/modules/clanovi.aspx';
$resultlist_url = 'http://manager.dojoexpert.com/modules/rezultati.aspx';

function iframe_shortcode_custom_js() {
    echo '<script type="text/javascript">var iframe_shortcode_plugins_url = \''.plugins_url('dojoexpert').'\';</script>';
}
add_action('admin_head', 'iframe_shortcode_custom_js');

function iframe_shortcode_register_settings() {
	add_option('iframe_shortcode_memberlist_url', 'http://manager.dojoexpert.com/modules/clanovi.aspx');
	add_option('iframe_shortcode_resultlist_url', 'http://manager.dojoexpert.com/modules/rezultati.aspx');
	add_option('iframe_shortcode_member_url', '/members/?');
	add_option('iframe_shortcode_lang_id', '1');
	add_option('iframe_shortcode_user', 'test');

	register_setting( 'default', 'iframe_shortcode_memberlist_url' ); 
	register_setting( 'default', 'iframe_shortcode_resultlist_url' ); 
	register_setting( 'default', 'iframe_shortcode_member_url' ); 
	register_setting( 'default', 'iframe_shortcode_lang_id' ); 
	register_setting( 'default', 'iframe_shortcode_user' ); 
} 
add_action( 'admin_init', 'iframe_shortcode_register_settings' );

function iframe_shortcode_register_options_page() {
	add_options_page('DojoExpert', 'DojoExpert', 'manage_options', 'iframe-shortcode-options', 'iframe_shortcode_options_page');
}
add_action('admin_menu', 'iframe_shortcode_register_options_page');

function iframe_shortcode_options_page() {
	?>
	<div class="wrap">
		<?php screen_icon(); ?>
		<h2>DojoExpert Setting Page</h2>
		<form method="post" action="options.php"> 
			<?php settings_fields( 'default' ); ?>			
			<table class="form-table">
				<tr valign="top" style="display: none">
					<th scope="row"><label for="iframe_shortcode_memberlist_url">Member list iframe URL?</label></th>
					<td><input type="text" id="iframe_shortcode_memberlist_url" name="iframe_shortcode_memberlist_url" value="<?php echo get_option('iframe_shortcode_memberlist_url'); ?>" /></td>
				</tr>
				<tr valign="top" style="display: none">
					<th scope="row"><label for="iframe_shortcode_resultlist_url">Result list iframe URL</label></th>
					<td><input type="text" id="iframe_shortcode_resultlist_url" name="iframe_shortcode_resultlist_url" value="<?php echo get_option('iframe_shortcode_resultlist_url'); ?>" /></td>
				</tr>
				<tr valign="top">
					<th scope="row"><label for="iframe_shortcode_member_url">Member page URL</label></th>
					<td><input type="text" id="iframe_shortcode_member_url" name="iframe_shortcode_member_url" value="<?php echo get_option('iframe_shortcode_member_url'); ?>" /></td>
				</tr>
				<tr valign="top">
					<th scope="row"><label for="iframe_shortcode_user">User</label></th>
					<td><input type="text" id="iframe_shortcode_user" name="iframe_shortcode_user" value="<?php echo get_option('iframe_shortcode_user'); ?>" /></td>
				</tr>
				<tr valign="top">
					<th scope="row"><label for="iframe_shortcode_lang_id">Language ID</label></th>
					<td><input type="text" id="iframe_shortcode_lang_id" name="iframe_shortcode_lang_id" value="<?php echo get_option('iframe_shortcode_lang_id'); ?>" /></td>
				</tr>
				<tr valign="top">
					<th><input class="button-primary" type="submit" value="<?php _e('Save Changes'); ?>"/></th>
					<td></td>
				</tr>
			</table>			
		</form>
	</div>
<?php
}

function iframe_shortcode_memberlist_html($atts) {
	// Get memberlist URL
	$iframe_shortcode_memberlist_url = get_option('iframe_shortcode_memberlist_url');
	if(!$iframe_shortcode_memberlist_url)
		$iframe_shortcode_memberlist_url = $memberlist_url;
		
	if(isset($_GET) && count($_GET) == 1){
		$keys = array_keys($_GET);
		$id = (int)$keys[0];
	}
	else{
		$id = isset($atts['id']) ? intval($atts['id']) : (isset($_GET['id']) ? intval($_GET['id']) : '');
	}

	if($id){
		$atts['id'] = $id;
	}
	
	//$id = isset($atts['id']) ? intval($atts['id']) : (isset($_GET['id']) ? intval($_GET['id']) : '');
	$atts['lang'] = get_option('iframe_shortcode_lang_id');
	$atts['user'] = get_option('iframe_shortcode_user');	
	$url = $iframe_shortcode_memberlist_url . '?'. http_build_query($atts);
	$html = @file_get_contents($url);
	return $html;
}

add_shortcode("memberlist", "iframe_shortcode_memberlist_html");

function iframe_shortcode_resultlist_html($atts) {
	// Get resultlist URL
	$iframe_shortcode_resultlist_url = get_option('iframe_shortcode_resultlist_url');		
	if(!$iframe_shortcode_resultlist_url)
		$iframe_shortcode_resultlist_url = $resultlist_url;
	$year = isset($atts['year']) ? intval($atts['year']) : 0;	
	$atts['memberURL'] = get_option('iframe_shortcode_member_url');
	$atts['lang'] = get_option('iframe_shortcode_lang_id');
	$atts['user'] = get_option('iframe_shortcode_user');

	if($year <= 0){
		$year = Date('Y');
	}

	$url = $iframe_shortcode_resultlist_url . '?'. http_build_query($atts);	
	$html = @file_get_contents($url);
	return $html;
}

add_shortcode("resultlist", "iframe_shortcode_resultlist_html");

add_action( 'admin_head', 'iframe_shortcode_add_tinymce' );

function iframe_shortcode_add_tinymce() {
    global $typenow;

    // only on Post Type: post and page
    if( ! in_array( $typenow, array( 'post', 'page' ) ) )
        return ;

    add_filter( 'mce_external_plugins', 'iframe_shortcode_add_tinymce_js' );
    add_filter( 'mce_buttons', 'iframe_shortcode_add_tinymce_button' );
}

function iframe_shortcode_add_tinymce_js( $plugin_array ) {
	$version = floatval(get_bloginfo('version')); 
	if($version < 3.9){
		$plugin_array['iframe_shortcode_memberlist'] = plugins_url( '/dojoexpert_v3.js', __FILE__ );    
		$plugin_array['iframe_shortcode_resultlist'] = plugins_url( '/dojoexpert_v3.js', __FILE__ );    
	}
	else{
		$plugin_array['iframe_shortcode'] = plugins_url( '/dojoexpert.js', __FILE__ );    
	}
    return $plugin_array;
}

function iframe_shortcode_add_tinymce_button( $buttons ) {
    array_push( $buttons, 'memberlist_button' );
    array_push( $buttons, 'resultlist_button' );
    return $buttons;
}
?>